import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingVip, BookingVipParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingVip(params: BookingVipParam) {
  const res = await request.get<ApiResult<PageResult<BookingVip>>>(
    MODULES_API_URL + '/booking/booking-vip/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingVip(params?: BookingVipParam) {
  const res = await request.get<ApiResult<BookingVip[]>>(
    MODULES_API_URL + '/booking/booking-vip',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingVip(data: BookingVip) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingVip(data: BookingVip) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-vip',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingVip(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-vip/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingVip(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-vip/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingVip(id: number) {
  const res = await request.get<ApiResult<BookingVip>>(
    MODULES_API_URL + '/booking/booking-vip/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
